<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { accessTokenKey, api, refreshTokenKey } from "~/common/constaint";
import _ from "lodash";
import { apiErrorHandler } from "~/utils/apiHanlers";
@Component({})
export default class UserSettingComponent extends Vue {
	payload = {
		password: "",
		newPassword: "",
		passwordConfirm: "",
	};

	isHidePassword = false;
	isHidePassword2 = false;
	isHidePassword3 = false;
	loading = false;

	async onChangePassword() {
		try {
			if (
				!(
					this.payload.password &&
					this.payload.newPassword &&
					this.payload.passwordConfirm
				)
			) {
				return this.$pushNotification.error(
					"Fields cannot be left blank"
				);
			} else if (this.payload.newPassword.length <= 6) {
				return this.$pushNotification.error(
					"Password must be 6 or more characters"
				);
			} else if (
				this.payload.newPassword !== this.payload.passwordConfirm
			) {
				return this.$pushNotification.error(
					"Two passwords do not match"
				);
			}
			this.loading = true;
			const response = await this.$api.user.changePassword(this.payload);
			if (response?.tokens) {
				const { accessToken, refreshToken } = response.tokens;
				this.$store.commit("user/setToken", {
					accessToken,
					refreshToken,
				});
				await this.$axios.setHeader(
					"Authorization",
					`Bearer ${accessToken}`
				);
				this.$localForage.setItem(accessTokenKey, accessToken);
				this.$localForage.setItem(refreshTokenKey, refreshToken);
				this.$pushNotification.success("Updated password successfully");
				this.payload = {
					password: "",
					newPassword: "",
					passwordConfirm: "",
				};
			}
		} catch (error) {
			apiErrorHandler(error, this);
		} finally {
			this.loading = false;
		}
	}

	get userInfo() {
		return this.$store.state.user.userInfo;
	}
}
</script>

<style>
</style>

